/*******************************************************************************
 * FoxUIItemDealWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIItemDealWidget extends FoxUIBaseUnlockWidget within GFxMoviePlayer
    native(UI);

var int DealWebHandle;
var const localized string TitleLabel;
var const localized string LeftLabel;
var const localized string OffLabel;
var const localized string ClickHereLabel;
var FoxSceneCaptureActor CaptureActor;

function Initialize(FoxPC PlayerController, optional FoxTypes.EFoxUnlockType ContainedUnlockType)
{
    ContainedUnlockType = 0;
    super.Initialize(PlayerController, ContainedUnlockType);
    Outer.Advance(0.50);
    CaptureActor = GetCaptureActor();
    SetString("DODString", TitleLabel);
    SetString("clickString", ClickHereLabel);
    SetString("extClickInterfaceFunc", "ei_selectItemDeal");
    //return;    
}

function ToggleVisible(bool bToggle)
{
    SetBool("_visible", bToggle);
    //return;    
}

function AddLeftArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addLeftArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

function AddRightArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addRightArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

function bool ApplyOfferItem(const StoreOfferMetaData Offer, optional out float CurrentDisplayTime)
{
    local BaseStoreEntry ItemEntry;
    local StoreMetaData StoreItem;
    local string TimeLeft, Description, NewIcon;
    local array<int> RenderUnlockIds;

    // End:0x3C4
    if(((((PCOwner != none) && PCOwner.DynamicUI != none) && GetStoreItemByGuid(Offer.ItemGuid, StoreItem)) && GetItemTileFromStoreItem(ItemEntry, StoreItem, Description)) && PCOwner.DynamicUI.GetDurationLabelFromTimeLeft(TimeLeft, Offer.EndDate, true, PCOwner.DynamicUI.TooltipBulletPointColor))
    {
        CurrentDisplayTime = 0.0;
        // End:0x1B1
        if((CaptureActor != none) && CaptureActor.GetIconStringForUnlockID(ItemEntry.UnlockID, NewIcon))
        {
            SetString("bigIconLoc", NewIcon);
        }
        // End:0x298
        else
        {
            // End:0x265
            if((CaptureActor != none) && CaptureActor.SetupRenderTargetByUnlockID(ItemEntry.UnlockID))
            {
                RenderUnlockIds[0] = ItemEntry.UnlockID;
                CaptureActor.SetRenderUnlocks(RenderUnlockIds, OnRenderComplete);
            }
            // End:0x298
            else
            {
                SetString("bigIconLoc", ItemEntry.sIcon);
            }
        }
        SetString("leftString", LeftLabel);
        SetString("timeLeft", TimeLeft);
        SetString("extClickInterfaceArg", StoreItem.ItemGuid);
        SetString("tooltip", ItemEntry.sTooltip);
        // End:0x379
        if(Description != "")
        {
            SetString("explainLabel1", Description);
        }
        // End:0x3AF
        else
        {
            SetString("explainLabel1", ItemEntry.sTooltip);
        }
        as_updateItem(ItemEntry);
        return true;
    }
    return false;
    //return ReturnValue;    
}

// Export UFoxUIItemDealWidget::execGetItemTileFromStoreItem(FFrame&, void* const)
protected native function bool GetItemTileFromStoreItem(out BaseStoreEntry ItemEntry, const out StoreMetaData StoreItem, optional out string Description);

protected function bool GetStoreItemByGuid(string ItemGuid, out StoreMetaData StoreItem)
{
    local FoxItemCacheStore StoreCache;

    return (class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) && StoreCache.GetCachedItemByGuid(StoreItem, ItemGuid)) && StoreItem.ItemGuid == ItemGuid;
    //return ReturnValue;    
}

protected function ei_selectItemDeal(string ItemGuid)
{
    PurchaseItem(ItemGuid, false);
    //return;    
}

protected function as_updateItem(const BaseStoreEntry ItemEntry)
{
    ActionScriptVoid("setItemInfo");
    //return;    
}

protected function as_addLeftArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupLeftArrow");
    //return;    
}

protected function as_addRightArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupRightArrow");
    //return;    
}

function as_showDealTexture(bool bShowWebTexture)
{
    ActionScriptVoid("showDealTexture");
    //return;    
}

function showWebDeal(bool bShowWebDeal)
{
    as_showDealTexture(bShowWebDeal);
    OpenDealWebImage("https://zombiestudios.s3.amazonaws.com/blr-offers/offer_image2.jpg");
    //return;    
}

function bool OpenDealWebImage(string URL)
{
    local Vector2D Size, Loc;
    local Texture2D BrowserTex;

    Size.X = 512.0;
    Size.Y = 256.0;
    Loc.X = 0.0;
    Loc.Y = 0.0;
    DealWebHandle = FoxGameViewportClient(Outer.GetGameViewportClient()).ViewportWebInteraction.RequestBrowser(URL, Loc, Size, false, true, false, false, false);
    // End:0x1EC
    if(DealWebHandle != -1)
    {
        GetObject("webPage_MC");
        SetFloat("webPageHandle", float(DealWebHandle));
        BrowserTex = FoxGameViewportClient(Outer.GetGameViewportClient()).ViewportWebInteraction.GetBrowserTexture(DealWebHandle);
        Outer.SetExternalTexture("tx_deal", BrowserTex);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function ei_cleanupDealWebImage()
{
    FoxGameViewportClient(Outer.GetGameViewportClient()).ViewportWebInteraction.CloseBrowser(DealWebHandle);
    //return;    
}

function Cleanup()
{
    super.Cleanup();
    ei_cleanupDealWebImage();
    //return;    
}

// Export UFoxUIItemDealWidget::execGetCaptureActor(FFrame&, void* const)
native function FoxSceneCaptureActor GetCaptureActor();

function OnRenderComplete(int UnlockID, string IconPath)
{
    SetString("bigIconLoc", "img://" $ IconPath);
    //return;    
}

defaultproperties
{
    TitleLabel="FEATURED ITEM!"
    LeftLabel="LEFT:"
    OffLabel="OFF"
    ClickHereLabel="CLICK TO PURCHASE"
    PurchaseLocation=EPurchaseLocation.EPLOC_Banner
    LocalizationSectionName="StoreTagsDecorated"
}